#include <gccore.h>
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <ogcsys.h>
#include <debug.h>
#include <fat.h>
#include <sdcard/gcsd.h>
#include <ogc/exi.h>

static void *xfb = NULL;

u32 first_frame = 1;
GXRModeObj *rmode;
vu16 oldstate;
vu16 keystate;
vu16 keydown;
vu16 keyup;
PADStatus pad[4];


int main()
{
    VIDEO_Init();

    rmode = VIDEO_GetPreferredMode(NULL);

    PAD_Init();


    xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));

    VIDEO_Configure(rmode);

    VIDEO_SetNextFramebuffer(xfb);

    VIDEO_SetBlack(FALSE);
    VIDEO_Flush();
    VIDEO_WaitVSync();
    if (rmode->viTVMode & VI_NON_INTERLACE)
        VIDEO_WaitVSync();


    console_init(xfb, 20, 20, rmode->fbWidth, rmode->xfbHeight, rmode->fbWidth * 2);

    printf("\n\nIPL dump\n");


    if (!fatMountSimple("sdb", &__io_gcsdb))
    {
        printf("Couldn't mount sdb\n");
    }
    else
    {
        char name[256];
        fatGetVolumeLabel("sdb", name);
        printf("Mounted %s as sdb\n", name);
    }

    printf("Reading IPL ROM\n");
    u32 ipl_buffer[2 * 1024 * 1024 / 4];
    u32 ipl_offset = 0;
    EXI_Select(EXI_CHANNEL_0, EXI_DEVICE_1, EXI_SPEED8MHZ);
    EXI_Imm(EXI_CHANNEL_0, &ipl_offset, 4, EXI_WRITE, NULL);
    EXI_Sync(EXI_CHANNEL_0);
    EXI_Dma(EXI_CHANNEL_0, ipl_buffer, 2 * 1024 * 1024, EXI_READ, NULL);
    EXI_Sync(EXI_CHANNEL_0);

    printf("Writing file ipl.rom\n");
    FILE *file = fopen("sdb:/ipl.rom", "wb");
    if (file != NULL)
    {
        //fwrite(ipl_buffer, 1, 2 * 1024 * 1024, file);
        fclose(file);
    }
    else
    {
        printf("Failed to open file");
    }

    printf("Unmounting sdb\n");
    fatUnmount("sdb");

    printf("Done !\n");

    while (1)
    {
        VIDEO_WaitVSync();
        PAD_ScanPads();

        int buttonsDown = PAD_ButtonsDown(0);

        if (buttonsDown & PAD_BUTTON_START)
        {
            exit(0);
        }
    }
}
